Description

When trying to search a numeric value fact and using operator '~' there a 500 error:

"PG::UndefinedFunction: ERROR:  operator does not exist: numeric ~~* integer

LINE 1: ... E'^\\d+$' AND CAST ILIKE 0)) ...

^

HINT:  No operator matches the given name and argument type(s). You might need to add explicit type casts."

recreate:

search- facts.uptime_days ~ 0

Related issues:

Related to Foreman - Feature #11150: Allow searching of facts as types other ... Closed 07/19/2015

Associated revisions

Revision 8658fa37 - 08/24/2015 03:05 PM - Imri Zvik

Fixes #11282 - Search on numeric facts is broken if using "~"

History

#1 - 08/04/2015 06:49 AM - Dominic Cleal

- Related to Feature #11150: Allow searching of facts as types other than string added

#2 - 08/04/2015 06:49 AM - Dominic Cleal

- translation missing: en.field_release set to 63

#3 - 08/05/2015 03:28 PM - Imri Zvik

Excluding the LIKE operator for PG in cast_facts solved this issue.

i.e.

instead of:

elsif (is_int && is_pg)

do:

elsif (is_int && is_pg && operator !~ /LIKE/i)

Dominic, if it sounds like an acceptable solution to you, I will open a PR.

#4 - 08/05/2015 03:31 PM - Ohad Levy

Imri Zvik wrote:

Excluding the LIKE operator for PG in cast_facts solved this issue.

i.e.

instead of:

elsif (is_int && is_pg)

do:

elsif (is_int && is_pg && operator !~ /LIKE/i)
Dominic, if it sounds like an acceptable solution to you, I will open a PR.

 I would suggest to open a PR and make sure you add the case mention here (and maybe others?) as a test?

thanks!

#5 - 08/05/2015 03:34 PM - Imri Zvik

Ohad Levy wrote:

Imri Zvik wrote:

Excluding the LIKE operator for PG in cast_facts solved this issue.

i.e.

instead of:

elsif (is_int && is_pg)

do:

elsif (is_int && is_pg && operator !~ /LIKE/i)

Dominic, if it sounds like an acceptable solution to you, I will open a PR.

 I would suggest to open a PR and make sure you add the case mention here (and maybe others?) as a test?

thanks!

 Already did in my fork ;)

I will open a PR tomorrow.

#6 - 08/19/2015 11:51 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2622 added

- Pull request deleted ()

#7 - 08/20/2015 03:40 AM - Dominic Cleal

- Status changed from Ready For Testing to New

- Pull request  added

- Pull request deleted (https://github.com/theforeman/foreman/pull/2622)

#8 - 08/20/2015 03:56 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/2626 added

- Pull request deleted ()

#9 - 08/24/2015 04:02 PM - Imri Zvik

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 8658fa37c1f86cb5a34629e443141b03a0175a94.

#10 - 08/25/2015 03:03 AM - Dominic Cleal

- Assignee set to Imri Zvik
